package com.hh.hhomc.utils;

import android.app.Activity;
import android.content.Intent;

public class K8DeviceUtils {


    // 隐藏导航栏
    public static void hideNavigationBar(Activity activity) {
        //发送广播
        Intent intentHideNavigationBar = new Intent();
        intentHideNavigationBar.setAction("com.android.internal.policy.impl.hideNavigationBar");
        activity.sendBroadcast(intentHideNavigationBar);
    }

    // 隐藏通知栏
    public static void hideStatusclose(Activity activity) {
        Intent intentStatusclose = new Intent();
        intentStatusclose.setAction("com.android.systemui.statusbar.phone.statusclose");
        activity.sendBroadcast(intentStatusclose);
    }

    // 显示导航栏
    public static void showNavigationBar(Activity activity) {
        Intent intentHideNavigationBar = new Intent();
        intentHideNavigationBar.setAction("com.android.internal.policy.impl.showNavigationBar");
        activity.sendBroadcast(intentHideNavigationBar);
    }

    // 显示通知栏
    public static void showStatusclose(Activity activity) {
        Intent intentStatusclose = new Intent();
        intentStatusclose.setAction("com.android.systemui.statusbar.phone.statusopen");
        activity.sendBroadcast(intentStatusclose);
    }

}
